#include <iostream>   
#include <sstream>   
#include <cstdio>   
#include <cstdlib>   
#include <cmath>   
#include <memory.h>   
#include <cctype>   
#include <string>   
#include <vector>   
#include <list>   
#include <queue>   
#include <deque>   
#include <stack>   
#include <map>   
#include <set>   
#include <algorithm>   
using namespace std;  
   
#define FOR(i,a,b) for(int (i) = (a); (i) < (b); ++(i))  
#define RFOR(i,a,b) for(int (i) = (a)-1; (i) >= (b); --(i))  
#define CLEAR(a) memset((a),0,sizeof(a))  
#define INF 1000000000  
#define PB push_back  
#define ALL(c) (c).begin(), (c).end()  
#define pi 2*acos(0.0)  
#define SQR(a) (a)*(a)  
#define MP make_pair 
#define MAX 128
#define BASE 1000000007
   
typedef unsigned long long Int;  

int T, n, m, k;
int A[64], B[64];

int main()
{
	cin >> T;
	FOR (t,0,T)
	{
		// rand n, k, m
		cin >> n >> k >> m;
		// read A[0] .. A[n-1]
		FOR (i,0,n)
			cin >> A[i];
		int res = INF;
		// iterate all bitmasks
		FOR (i,0,(1 << n))
		{
			int cnt = 0;

			// increment all A[i] such that i-th bit in i is 1
			// and count cnt --- the number of increments
			FOR (j,0,n)
			{
				B[j] = A[j];
				if ((i & (1 << j)) != 0)
				{
					B[j]++;
					cnt++;
				}
			}
			if (cnt >= res)
				continue;
			bool ok = true;
			// check whether elephants will be arrested or not
			for (int j = 0; j+k-1 < n; j++)
			{
				// find maximum
				int mx = 0;
				FOR (l,0,k)
					mx = max(mx, B[j+l]);
				// find number of mixumums
				int c = 0;
				FOR (l,0,k)
					c += (B[j+l] == mx);
				// check
				if (c >= m)
					ok = false;
			}
			// if not, try to make result better
			if (ok)
				res = min(res, cnt);
		}
		
		// output the result
		if (res >= INF)
			cout << -1 << endl;
		else
			cout << res << endl;
	}

	return 0;
}
	